#include <windows.h>
#include <stdio.h>
#include "ps3000.h"

short _ready = 0;
short *_buffers[] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
unsigned long _bufferSizes[] = {0, 0, 0, 0, 0, 0, 0, 0};
short _overflow;
unsigned long _triggeredAt;
short _triggered;
short _auto_stop;
unsigned long _nValues;

void __stdcall GetValuesCallback(short **overviewBuffers, short overflow, unsigned long triggeredAt, short triggered,
  short auto_stop,unsigned long nValues)
{    
  if(_ready == 0)
  {
    int co = 0;
    for(co = 0; co < 8; co++)
    {      
      if(overviewBuffers[co] != NULL && _buffers[co] != NULL)
      {
        unsigned long bufferSize = (nValues > _bufferSizes[co] ? _bufferSizes[co] : nValues);      
        memcpy(_buffers[co], overviewBuffers[co], bufferSize * sizeof(short));
      }
    }

	  _overflow = overflow;
	  _triggeredAt = triggeredAt;
	  _triggered = triggered;
	  _auto_stop = auto_stop;
	  _nValues = nValues;
	  _ready = 1;
  }
}

extern short __declspec(dllexport) __stdcall PollFastStreaming(short handle)
{
	_ready = 0;
  return ps3000_get_streaming_last_values(handle, (void *)GetValuesCallback);
}

extern void __declspec(dllexport) __stdcall SetBuffer(short handle, short channel, short * buffer, unsigned long bufferSize)
{
		short index = channel * 2;
    if(index >=8) return;
    
    _buffers[index] = _buffers[index + 1] = NULL;
    _bufferSizes[index] = bufferSize;

    if(buffer != NULL) _buffers[index] = buffer;
}

extern void __declspec(dllexport) __stdcall SetAggregateBuffer(short handle, short channel, short * bufferMax, short * bufferMin, unsigned long bufferSize)
{
    short index = channel * 2;
    if(index >=8) return;

    _buffers[index] = _buffers[index + 1] = NULL;
    _bufferSizes[index] = _bufferSizes[index + 1] = bufferSize;

    if(bufferMax != NULL) _buffers[index] = bufferMax;
    if(bufferMin != NULL) _buffers[index + 1] = bufferMin;
}


extern short __declspec(dllexport) __stdcall FastStreamingReady(short handle)
{
	return _ready;
}

extern unsigned long __declspec(dllexport) __stdcall GetFastStreamingDetails(short handle, short * overflow, unsigned long * triggeredAt, 
		short * triggered, short * auto_stop)
{
	if(_ready)
	{
		*overflow = _overflow;
		*triggeredAt = _triggeredAt;
		*triggered = _triggered;
		*auto_stop = _auto_stop;	
		return _nValues;
	}
	else
	{
		*overflow = (short)0;
		*triggeredAt = (unsigned long)0;
		*triggered = (short)0;
		*auto_stop = (short)0;			
		return 0;
	}
}
